﻿using System;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Configuration;

namespace GOST
{
    public partial class MainForm : Form
    {
        private GOST2814789 gost;
        private byte[] cryptmes;

        public MainForm()
        {
            InitializeComponent();

        }

        private void bCrypt_Click(object sender, EventArgs e)
        {
           
            this.tbKey.Text = this.gost.Key;
            this.cryptmes = this.gost.Crypt(this.tbMessage.Text);
            this.tbcryptMes.Text = this.gost.ToStringFromByteArray(this.cryptmes);
          // if (!File.Exists(Application.StartupPath + "cryptmes.crypt"))
           // FileStream fsc = new FileStream(Application.StartupPath + "cryptmes.crypt", FileMode.CreateNew);
           // else
            FileStream fsc = new FileStream(Application.StartupPath + "\\cryptmes.crypt", FileMode.OpenOrCreate);
            BinaryWriter bw = new BinaryWriter(fsc);
            bw.Write(this.cryptmes);
            bw.Close();
            fsc.Close();
        }

        private void bDecryptMes_Click(object sender, EventArgs e)
        {
            this.tbKey.Text = this.gost.Key;
            if (this.cryptmes == null)
            {
                this.cryptmes = System.Text.Encoding.UTF8.GetBytes(this.tbcryptMes.Text);
            }
            this.tbDecryptMes.Text =  this.gost.Decrypt(this.cryptmes);

        }

        private void bGenKey_Click(object sender, EventArgs e)
        {
            if (this.gost == null)
            {
                System.Text.UTF8Encoding enc = new System.Text.UTF8Encoding();
                if (this.tbKey.Text != "")
                {
                    this.gost = new GOST2814789(enc.GetBytes(this.tbKey.Text));
                }
                else
                {
                    this.gost = new GOST2814789();
                }
            }
            else
            {
                this.gost.GenerateKey();
            }
            this.tbKey.Text = this.gost.Key;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            if (Properties.Settings.Default["key"] == null)
            {
                this.gost = new GOST2814789();
                Properties.Settings.Default["key"] = this.gost.Key;
                this.tbKey.Text = this.gost.Key;
                Properties.Settings.Default.Save();
            }
            else
            {
                this.gost = new GOST2814789((byte[])Properties.Settings.Default["key"]);
                this.tbKey.Text = this.gost.Key;
            }
            

        }

       
        private void button1_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string pathtofile = this.openFileDialog1.FileName;
                FileStream fs = new FileStream(pathtofile, FileMode.Open);
                this.gost.Crypt(fs);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog2.ShowDialog() == DialogResult.OK)
            {
                string pathtofile = this.openFileDialog2.FileName;
                FileStream fs = new FileStream(pathtofile, FileMode.Open);
                this.gost.Decrypt(fs);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (this.openFileDialog2.ShowDialog() == DialogResult.OK)
            {
                string pathtofile = this.openFileDialog2.FileName;
                FileStream fs = new FileStream(pathtofile, FileMode.Open);
                //this.gost.Decrypt(fs);
                BinaryReader br = new BinaryReader(fs);
                this.cryptmes = br.ReadBytes((int)fs.Length);
             //   System.Text.Encoding.UTF8.GetBytes(
                this.tbcryptMes.Text = System.Text.Encoding.UTF8.GetString(this.cryptmes);
            
                this.tbDecryptMes.Text =  this.gost.Decrypt(this.cryptmes);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            FileStream fsc = new FileStream(Application.StartupPath + "\\key.key", FileMode.OpenOrCreate);
            BinaryWriter bw = new BinaryWriter(fsc);
            bw.Write(this.gost.KeyByte);
            bw.Close();
            fsc.Close();
        }

        private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            Properties.Settings.Default["key"] = this.gost.KeyByte;
            Properties.Settings.Default.Save();
        }

       

    }
}